summaryrefslogtreecommitdiff
path: root/functions/losetup.sh
diff options
context:
space:
mode:
authorDaniel Baumann <daniel@debian.org>2007-11-14 09:55:50 +0100
committerDaniel Baumann <daniel@debian.org>2011-03-09 18:22:29 +0100
commitc6236a0794c598d82aa470ca7b358bd1d0986aa1 (patch)
tree99362671c4e5af013d79e3757022b52b6999c9f5 /functions/losetup.sh
parentb5dc2031264b83c837451f3c09ab1cbbc4cd6047 (diff)
downloadlive-build-c6236a0794c598d82aa470ca7b358bd1d0986aa1.zip
live-build-c6236a0794c598d82aa470ca7b358bd1d0986aa1.tar.gz
Moving lh_losetup into an internal function, avoiding helper failure with return value due to new trap.
Diffstat (limited to 'functions/losetup.sh')
-rwxr-xr-xfunctions/losetup.sh37
1 files changed, 37 insertions, 0 deletions
diff --git a/functions/losetup.sh b/functions/losetup.sh
new file mode 100755
index 0000000..4ca1d5f
--- /dev/null
+++ b/functions/losetup.sh
@@ -0,0 +1,37 @@
+#!/bin/sh
+
+# losetup - wrapper around losetup
+# Copyright (C) 2006-2007 Daniel Baumann <daniel@debian.org>
+#
+# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
+# This is free software, and you are welcome to redistribute it
+# under certain conditions; see COPYING for details.
+
+set -e
+
+Losetup ()
+{
+ DEVICE="${1}"
+ FILE="${2}"
+ PARTITION="${3:=1}"
+
+ ${LH_ROOT_COMMAND} ${LH_LOSETUP} "${DEVICE}" "${FILE}"
+ FDISK_OUT="$(LH_FDISK -l -u ${DEVICE} 2>&1)"
+ ${LH_ROOT_COMMAND} ${LH_LOSETUP} -d "${DEVICE}"
+
+ LOOPDEVICE="$(echo ${DEVICE}p${PARTITION})"
+
+ if [ "${PARTITION}" = "0" ]
+ then
+ Echo_message "Mounting ${DEVICE} with offset 0"
+
+ ${LH_ROOT_COMMAND} ${LH_LOSETUP} "${DEVICE}" "${FILE}"
+ else
+ CYLINDERS="$(echo "$FDISK_OUT" | sed -ne "s_^$LOOPDEVICE[ *]*\([0-9]*\).*_\1_p")"
+ OFFSET="$(expr ${CYLINDERS} '*' 512)"
+
+ Echo_message "Mounting ${DEVICE} with offset ${OFFSET}"
+
+ ${LH_ROOT_COMMAND} ${LH_LOSETUP} -o "${OFFSET}" "${DEVICE}" "${FILE}"
+ fi
+}